<?php

namespace Teknisa\FIN\Modules\ContaPagar\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Row as RowBirt;
use Zeedhi\Framework\Remote\cURLRequest;
use Zeedhi\Framework\Remote\HttpInterface;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO;
use Teknisa\FIN\Modules\ContaPagar\Services\Pag30000RetornoDDAService;
use Zeedhi\Framework\Controller\Report;


class Pag30000RetornoDDAController extends Report{

    protected $dataSourceName;
    CONST REPORTNAME = 'InconsistenciasDDA';

    public function __construct($reportService, Pag30000RetornoDDAService $pag30000RetornoDDAService){
        $this->pag30000RetornoDDAService = $pag30000RetornoDDAService;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        self::REPORTNAME =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array ()
            )
    );

    public function importaRetornoDDA(DTO\Request\Row $request, DTO\Response $response){
        try{
            set_time_limit(0);
            $row = $request->getRow();
            $retornoDDA = $this->pag30000RetornoDDAService->importaRetornoDDA($row);
            $retornoDDA = ($retornoDDA) ? $retornoDDA : [];
            $response->addDataSet(new DataSet("retornoDDA", $retornoDDA));
        }catch(\Exception $e){
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }

    private function geraRelatorioRetorno($request, $response) {

        $urlRelatorio = null;
        try {
            $nomeRelatorioRetorno = self::REPORTNAME;

            if (!empty($nomeRelatorioRetorno)) {
                $rowBirt = new RowBirt();

                $rowBirt->set("__report_name", $nomeRelatorioRetorno);
                $rowBirt->set("MOD_PATH", 'fin');

                $requestBirt = new Request\Row($rowBirt, "POST", "/createRemoteReport", $request->getUserId());
                $this->createRemoteReport($requestBirt, $response);

                $urlRelatorio = $response->getMessages()[0]->getMessage();
                $urlRelatorio = str_replace("&__format=pdf", "&__format=xls", $urlRelatorio);
            }
        } catch (\Exception $e) {
            throw $e;
        }
        return $urlRelatorio;
    }

    private function salvarRelatorio($nomeArquivo, $reportUrl) {
        $reportPath = null;
        try {

            $cURLRequest = new cURLRequest($reportUrl);
            $report = $cURLRequest->request('');
            $requestInfo = $cURLRequest->getRequestInfo();
            if ($requestInfo['http_code'] !== HTTPInterface::STATUS_CODE_OK)
                throw new \Exception('Ocorreu um erro inesperado ao salvar o relatório.');

            // Caminho para teste local
            $reportPath = 'C:/workfolder/anexos/' . $nomeArquivo . '.xls';

            /*if (is_dir('/tmp'))
                $reportPath = '/tmp/' . $nomeArquivo . '.pdf';
            else $reportPath = __DIR__ . DIRECTORY_SEPARATOR . $nomeArquivo . '.pdf';*/

            file_put_contents($reportPath, $report);

            unset($report);
            unset($cURLRequest);

        }catch (\Exception $e) {
            throw $e;
        }
        return $reportPath;
    }

}